program pInstaller;
{ NOTES : for version 3, consider handling JSync Installer remote download and installation}
{ NOTES : Uninstall errors are being populated and will be displayed in a future version}

{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}

{****************************************************************************
IMPORTANT NOTE:
In order for this to function correctly, the version information
**MUST BE SET** in the Delphi Project

****************************************************************************}

//I've changed the license to LGPL to avoid legal problems distributing non-free
//software and linking with palm's libraries, etc.


// --------------------------------------------------------------------------
// version 1.6.0.0 - mostly this version is just a code cleanup
// the code has been moved into the TConduitInstaller object
//  This version has not been tested at this point, I'm just
//  posting it for review
//
//  New Features:
//  --Optional Files: you can now specify optional files for the
//    user to select.  Two sections are added to the .ini to
//    accomidate this - "Optional File Names" and "Optional File Descriptions"
//    each section consist of a series of Filenn values, much like the
//    additional files section.
//  --ShortCuts: The framework is in place, but I haven't implemented this
//    yet.  Two sections - "Shortcut Files" and "Shortcut Descriptions" control this.
//    in the next release, I'll have this functioning.
//  --Com Support is now flushed out and should work

//written by handX software
//Copyright (C) 2001 handX software

//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.

//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this library; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

//  ****IMPORTANT NOTE****
//  If you distribute modify installer code, you should change the name of the executable
//  that you distribute If you don't, this may cause problems with the ConduitInstaller
//  uninstall functionality, both for your application and other programs installed with
//  conduitInstaller.
//
// --------------------------------------------------------------------------
// If you have questions, improvements or other feedback, please contact
// support@handx.net.  You can also find discussion of this product hosted on
// the TurboSync yahoo group.  Visit http://groups.yahoo.com/group/TurboSync
//
// --------------------------------------------------------------------------


{%ToDo 'pInstaller.todo'}
{%File 'testingNotes.txt'}
{%File 'readme.html'}

uses
  Forms,
  windows,
  classes,
  dialogs,
  SysUtils,
  messages,
  registry,
  inifiles,
  hxInstallUtilities in 'hxInstallUtilities.pas',
  hXxmlUtils in 'hXxmlUtils.pas',
  installationWizardForm in 'installationWizardForm.pas' {frmInstallationWizard},
  pInstallerTypes in 'pInstallerTypes.pas';

{$R *.RES}

var
  installer: TPalmInstaller;

{------------------------------------------------------------------------------------------
*******************************************************************************************
main block
Description:
installs a conduit
*******************************************************************************************
------------------------------------------------------------------------------------------}
begin
Application.Initialize;
installer := TPalmInstaller.Create;

//uninstall if needed
if (ProcessParam(paramstr(1)) = 'u') then
  begin
  installer.uninstall;
  installer.Free;
  exit;
  end; //if ProcessParam(paramstr(1)) = 'u'

if not fileExists(IncludeTrailingPathDelimiter(extractFilePath(paramStr(0)))+'settings.xml') then
  begin
  Application.MessageBox('The installer setting file was unable to load a settings file.',
                         'Installation Aborted', MB_ICONERROR);
  exit;
  end;
try
   installer.loadXML(IncludeTrailingPathDelimiter(extractFilePath(paramStr(0)))+'settings.xml');
except
 on e : ESettingsError do
   begin
   Application.MessageBox(PChar('The installer setting file was unable to load.  ' + #10#13
                           + e.message), 'Installation Aborted', MB_ICONERROR);
   installer.Free;
   exit;
   end;
end;

if (installer.palmFilesToInstall) or (installer.conduitSelectedForInstallation) then
  installer.initializeLibraries;

installer.execute;
installer.Free;

end.
